//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#ifndef __MuQt5__QBoxLayoutType__h__
#define __MuQt5__QBoxLayoutType__h__
#include <iostream>
#include <Mu/Class.h>
#include <Mu/MuProcess.h>
#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtNetwork/QtNetwork>
#include <QtWebEngine/QtWebEngine>
#include <QtWebEngineWidgets/QtWebEngineWidgets>
#include <QtQml/QtQml>
#include <QtQuick/QtQuick>
#include <QtQuickWidgets/QtQuickWidgets>
#include <QtSvg/QtSvg>
#include <MuQt5/Bridge.h>

namespace Mu
{
    class MuQt_QBoxLayout;

    //
    //  NOTE: file generated by qt2mu.py
    //

    class QBoxLayoutType : public Class
    {
    public:
        typedef MuQt_QBoxLayout MuQtType;
        typedef QBoxLayout QtType;

        //
        //  Constructors
        //

        QBoxLayoutType(Context* context, const char* name,
                       Class* superClass = 0, Class* superClass2 = 0);

        virtual ~QBoxLayoutType();

        static bool isInheritable() { return true; }

        static inline ClassInstance* cachedInstance(const MuQtType*);

        //
        //  Class API
        //

        virtual void load();

        MemberFunction* _func[18];
    };

    // Inheritable object

    class MuQt_QBoxLayout : public QBoxLayout
    {
    public:
        virtual ~MuQt_QBoxLayout();
        MuQt_QBoxLayout(Pointer muobj, const CallEnvironment*,
                        QBoxLayout::Direction dir, QWidget* parent);
        virtual void addItem(QLayoutItem* item);
        virtual int count() const;
        virtual Qt::Orientations expandingDirections() const;
        virtual bool hasHeightForWidth() const;
        virtual int heightForWidth(int w) const;
        virtual void invalidate();
        virtual QLayoutItem* itemAt(int index) const;
        virtual QSize maximumSize() const;
        virtual int minimumHeightForWidth(int w) const;
        virtual QSize minimumSize() const;
        virtual void setGeometry(const QRect& r);
        virtual QSize sizeHint() const;
        virtual QLayoutItem* takeAt(int index);
        virtual int indexOf(QWidget* widget) const;
        virtual QSizePolicy::ControlTypes controlTypes() const;
        virtual QRect geometry() const;
        virtual bool isEmpty() const;
        virtual QLayout* layout();

    public:
        const QBoxLayoutType* _baseType;
        ClassInstance* _obj;
        const CallEnvironment* _env;
    };

    inline ClassInstance*
    QBoxLayoutType::cachedInstance(const QBoxLayoutType::MuQtType* obj)
    {
        return obj->_obj;
    }

} // namespace Mu

#endif // __MuQt__QBoxLayoutType__h__
