//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#ifndef __MuQt5__QCompleterType__h__
#define __MuQt5__QCompleterType__h__
#include <iostream>
#include <Mu/Class.h>
#include <Mu/MuProcess.h>
#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtNetwork/QtNetwork>
#include <QtWebEngine/QtWebEngine>
#include <QtWebEngineWidgets/QtWebEngineWidgets>
#include <QtQml/QtQml>
#include <QtQuick/QtQuick>
#include <QtQuickWidgets/QtQuickWidgets>
#include <QtSvg/QtSvg>
#include <MuQt5/Bridge.h>

namespace Mu
{
    class MuQt_QCompleter;

    //
    //  NOTE: file generated by qt2mu.py
    //

    class QCompleterType : public Class
    {
    public:
        typedef MuQt_QCompleter MuQtType;
        typedef QCompleter QtType;

        //
        //  Constructors
        //

        QCompleterType(Context* context, const char* name,
                       Class* superClass = 0, Class* superClass2 = 0);

        virtual ~QCompleterType();

        static bool isInheritable() { return true; }

        static inline ClassInstance* cachedInstance(const MuQtType*);

        //
        //  Class API
        //

        virtual void load();

        MemberFunction* _func[6];
    };

    // Inheritable object

    class MuQt_QCompleter : public QCompleter
    {
    public:
        virtual ~MuQt_QCompleter();
        MuQt_QCompleter(Pointer muobj, const CallEnvironment*, QObject* parent);
        MuQt_QCompleter(Pointer muobj, const CallEnvironment*,
                        QAbstractItemModel* model, QObject* parent);
        MuQt_QCompleter(Pointer muobj, const CallEnvironment*,
                        const QStringList& list, QObject* parent);
        virtual QString pathFromIndex(const QModelIndex& index) const;
        virtual QStringList splitPath(const QString& path) const;

    protected:
        virtual bool event(QEvent* ev);
        virtual bool eventFilter(QObject* o, QEvent* e);
        virtual void customEvent(QEvent* event);
        virtual void timerEvent(QTimerEvent* event);

    public:
        bool event_pub(QEvent* ev) { return event(ev); }

        bool event_pub_parent(QEvent* ev) { return QCompleter::event(ev); }

        bool eventFilter_pub(QObject* o, QEvent* e)
        {
            return eventFilter(o, e);
        }

        bool eventFilter_pub_parent(QObject* o, QEvent* e)
        {
            return QCompleter::eventFilter(o, e);
        }

        void customEvent_pub(QEvent* event) { customEvent(event); }

        void customEvent_pub_parent(QEvent* event)
        {
            QCompleter::customEvent(event);
        }

        void timerEvent_pub(QTimerEvent* event) { timerEvent(event); }

        void timerEvent_pub_parent(QTimerEvent* event)
        {
            QCompleter::timerEvent(event);
        }

    public:
        const QCompleterType* _baseType;
        ClassInstance* _obj;
        const CallEnvironment* _env;
    };

    inline ClassInstance*
    QCompleterType::cachedInstance(const QCompleterType::MuQtType* obj)
    {
        return obj->_obj;
    }

} // namespace Mu

#endif // __MuQt__QCompleterType__h__
