//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#ifndef __MuQt5__QGuiApplicationType__h__
#define __MuQt5__QGuiApplicationType__h__
#include <iostream>
#include <Mu/Class.h>
#include <Mu/MuProcess.h>
#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtNetwork/QtNetwork>
#include <QtWebEngine/QtWebEngine>
#include <QtWebEngineWidgets/QtWebEngineWidgets>
#include <QtQml/QtQml>
#include <QtQuick/QtQuick>
#include <QtQuickWidgets/QtQuickWidgets>
#include <QtSvg/QtSvg>
#include <MuQt5/Bridge.h>

namespace Mu
{
    class MuQt_QGuiApplication;

    //
    //  NOTE: file generated by qt2mu.py
    //

    class QGuiApplicationType : public Class
    {
    public:
        typedef MuQt_QGuiApplication MuQtType;
        typedef QGuiApplication QtType;

        //
        //  Constructors
        //

        QGuiApplicationType(Context* context, const char* name,
                            Class* superClass = 0, Class* superClass2 = 0);

        virtual ~QGuiApplicationType();

        static bool isInheritable() { return true; }

        static inline ClassInstance* cachedInstance(const MuQtType*);

        //
        //  Class API
        //

        virtual void load();

        MemberFunction* _func[2];
    };

    // Inheritable object

    class MuQt_QGuiApplication : public QGuiApplication
    {
    public:
        virtual ~MuQt_QGuiApplication();
        virtual bool notify(QObject* object, QEvent* event);

    protected:
        virtual bool event(QEvent* e);

    public:
        bool event_pub(QEvent* e) { return event(e); }

        bool event_pub_parent(QEvent* e) { return QGuiApplication::event(e); }

    public:
        const QGuiApplicationType* _baseType;
        ClassInstance* _obj;
        const CallEnvironment* _env;
    };

    inline ClassInstance* QGuiApplicationType::cachedInstance(
        const QGuiApplicationType::MuQtType* obj)
    {
        return obj->_obj;
    }

} // namespace Mu

#endif // __MuQt__QGuiApplicationType__h__
