//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#ifndef __MuQt5__QMimeDataType__h__
#define __MuQt5__QMimeDataType__h__
#include <iostream>
#include <Mu/Class.h>
#include <Mu/MuProcess.h>
#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtNetwork/QtNetwork>
#include <QtWebEngine/QtWebEngine>
#include <QtWebEngineWidgets/QtWebEngineWidgets>
#include <QtQml/QtQml>
#include <QtQuick/QtQuick>
#include <QtQuickWidgets/QtQuickWidgets>
#include <QtSvg/QtSvg>
#include <MuQt5/Bridge.h>

namespace Mu
{
    class MuQt_QMimeData;

    //
    //  NOTE: file generated by qt2mu.py
    //

    class QMimeDataType : public Class
    {
    public:
        typedef MuQt_QMimeData MuQtType;
        typedef QMimeData QtType;

        //
        //  Constructors
        //

        QMimeDataType(Context* context, const char* name, Class* superClass = 0,
                      Class* superClass2 = 0);

        virtual ~QMimeDataType();

        static bool isInheritable() { return true; }

        static inline ClassInstance* cachedInstance(const MuQtType*);

        //
        //  Class API
        //

        virtual void load();

        MemberFunction* _func[7];
    };

    // Inheritable object

    class MuQt_QMimeData : public QMimeData
    {
    public:
        virtual ~MuQt_QMimeData();
        MuQt_QMimeData(Pointer muobj, const CallEnvironment*);
        virtual QStringList formats() const;
        virtual bool hasFormat(const QString& mimeType) const;

    protected:
        virtual QVariant retrieveData(const QString& mimeType,
                                      QVariant::Type type) const;

    public:
        virtual bool event(QEvent* e);
        virtual bool eventFilter(QObject* watched, QEvent* event);

    protected:
        virtual void customEvent(QEvent* event);
        virtual void timerEvent(QTimerEvent* event);

    public:
        QVariant retrieveData_pub(const QString& mimeType,
                                  QVariant::Type type) const
        {
            return retrieveData(mimeType, type);
        }

        QVariant retrieveData_pub_parent(const QString& mimeType,
                                         QVariant::Type type) const
        {
            return QMimeData::retrieveData(mimeType, type);
        }

        void customEvent_pub(QEvent* event) { customEvent(event); }

        void customEvent_pub_parent(QEvent* event)
        {
            QMimeData::customEvent(event);
        }

        void timerEvent_pub(QTimerEvent* event) { timerEvent(event); }

        void timerEvent_pub_parent(QTimerEvent* event)
        {
            QMimeData::timerEvent(event);
        }

    public:
        const QMimeDataType* _baseType;
        ClassInstance* _obj;
        const CallEnvironment* _env;
    };

    inline ClassInstance*
    QMimeDataType::cachedInstance(const QMimeDataType::MuQtType* obj)
    {
        return obj->_obj;
    }

} // namespace Mu

#endif // __MuQt__QMimeDataType__h__
