//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#ifndef __MuQt5__QObjectType__h__
#define __MuQt5__QObjectType__h__
#include <iostream>
#include <Mu/Class.h>
#include <Mu/MuProcess.h>
#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtNetwork/QtNetwork>
#include <QtWebEngine/QtWebEngine>
#include <QtWebEngineWidgets/QtWebEngineWidgets>
#include <QtQml/QtQml>
#include <QtQuick/QtQuick>
#include <QtQuickWidgets/QtQuickWidgets>
#include <QtSvg/QtSvg>
#include <MuQt5/Bridge.h>

namespace Mu
{
    class MuQt_QObject;

    //
    //  NOTE: file generated by qt2mu.py
    //

    class QObjectType : public Class
    {
    public:
        struct Struct
        {
            QObject* object;
        };

        typedef MuQt_QObject MuQtType;
        typedef QObject QtType;

        //
        //  Constructors
        //

        QObjectType(Context* context, const char* name, Class* superClass = 0,
                    Class* superClass2 = 0);

        virtual ~QObjectType();

        static bool isInheritable() { return true; }

        static inline ClassInstance* cachedInstance(const MuQtType*);

        //
        //  Class API
        //

        virtual void load();

        MemberFunction* _func[4];
    };

    // Inheritable object

    class MuQt_QObject : public QObject
    {
    public:
        virtual ~MuQt_QObject();
        MuQt_QObject(Pointer muobj, const CallEnvironment*, QObject* parent);
        virtual bool event(QEvent* e);
        virtual bool eventFilter(QObject* watched, QEvent* event);

    protected:
        virtual void customEvent(QEvent* event);
        virtual void timerEvent(QTimerEvent* event);

    public:
        void customEvent_pub(QEvent* event) { customEvent(event); }

        void customEvent_pub_parent(QEvent* event)
        {
            QObject::customEvent(event);
        }

        QObject* sender_pub() const { return sender(); }

        QObject* sender_pub_parent() const { return QObject::sender(); }

        int senderSignalIndex_pub() const { return senderSignalIndex(); }

        int senderSignalIndex_pub_parent() const
        {
            return QObject::senderSignalIndex();
        }

        void timerEvent_pub(QTimerEvent* event) { timerEvent(event); }

        void timerEvent_pub_parent(QTimerEvent* event)
        {
            QObject::timerEvent(event);
        }

    public:
        const QObjectType* _baseType;
        ClassInstance* _obj;
        const CallEnvironment* _env;
    };

    inline ClassInstance*
    QObjectType::cachedInstance(const QObjectType::MuQtType* obj)
    {
        return obj->_obj;
    }

} // namespace Mu

#endif // __MuQt__QObjectType__h__
