//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#ifndef __MuQt5__QSliderType__h__
#define __MuQt5__QSliderType__h__
#include <iostream>
#include <Mu/Class.h>
#include <Mu/MuProcess.h>
#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtNetwork/QtNetwork>
#include <QtWebEngine/QtWebEngine>
#include <QtWebEngineWidgets/QtWebEngineWidgets>
#include <QtQml/QtQml>
#include <QtQuick/QtQuick>
#include <QtQuickWidgets/QtQuickWidgets>
#include <QtSvg/QtSvg>
#include <MuQt5/Bridge.h>

namespace Mu
{
    class MuQt_QSlider;

    //
    //  NOTE: file generated by qt2mu.py
    //

    class QSliderType : public Class
    {
    public:
        typedef MuQt_QSlider MuQtType;
        typedef QSlider QtType;

        //
        //  Constructors
        //

        QSliderType(Context* context, const char* name, Class* superClass = 0,
                    Class* superClass2 = 0);

        virtual ~QSliderType();

        static bool isInheritable() { return true; }

        static inline ClassInstance* cachedInstance(const MuQtType*);

        //
        //  Class API
        //

        virtual void load();

        MemberFunction* _func[11];
    };

    // Inheritable object

    class MuQt_QSlider : public QSlider
    {
    public:
        virtual ~MuQt_QSlider();
        MuQt_QSlider(Pointer muobj, const CallEnvironment*, QWidget* parent);
        MuQt_QSlider(Pointer muobj, const CallEnvironment*,
                     Qt::Orientation orientation, QWidget* parent);
        virtual bool event(QEvent* event_);
        virtual QSize minimumSizeHint() const;
        virtual QSize sizeHint() const;

    protected:
        virtual void mouseMoveEvent(QMouseEvent* ev);
        virtual void mousePressEvent(QMouseEvent* ev);
        virtual void mouseReleaseEvent(QMouseEvent* ev);
        virtual void paintEvent(QPaintEvent* ev);
        virtual void changeEvent(QEvent* ev);
        virtual void keyPressEvent(QKeyEvent* ev);
        virtual void timerEvent(QTimerEvent* e);
        virtual void wheelEvent(QWheelEvent* e);

    public:
        void mouseMoveEvent_pub(QMouseEvent* ev) { mouseMoveEvent(ev); }

        void mouseMoveEvent_pub_parent(QMouseEvent* ev)
        {
            QSlider::mouseMoveEvent(ev);
        }

        void mousePressEvent_pub(QMouseEvent* ev) { mousePressEvent(ev); }

        void mousePressEvent_pub_parent(QMouseEvent* ev)
        {
            QSlider::mousePressEvent(ev);
        }

        void mouseReleaseEvent_pub(QMouseEvent* ev) { mouseReleaseEvent(ev); }

        void mouseReleaseEvent_pub_parent(QMouseEvent* ev)
        {
            QSlider::mouseReleaseEvent(ev);
        }

        void paintEvent_pub(QPaintEvent* ev) { paintEvent(ev); }

        void paintEvent_pub_parent(QPaintEvent* ev) { QSlider::paintEvent(ev); }

        void changeEvent_pub(QEvent* ev) { changeEvent(ev); }

        void changeEvent_pub_parent(QEvent* ev) { QSlider::changeEvent(ev); }

        void keyPressEvent_pub(QKeyEvent* ev) { keyPressEvent(ev); }

        void keyPressEvent_pub_parent(QKeyEvent* ev)
        {
            QSlider::keyPressEvent(ev);
        }

        void timerEvent_pub(QTimerEvent* e) { timerEvent(e); }

        void timerEvent_pub_parent(QTimerEvent* e) { QSlider::timerEvent(e); }

        void wheelEvent_pub(QWheelEvent* e) { wheelEvent(e); }

        void wheelEvent_pub_parent(QWheelEvent* e) { QSlider::wheelEvent(e); }

    public:
        const QSliderType* _baseType;
        ClassInstance* _obj;
        const CallEnvironment* _env;
    };

    inline ClassInstance*
    QSliderType::cachedInstance(const QSliderType::MuQtType* obj)
    {
        return obj->_obj;
    }

} // namespace Mu

#endif // __MuQt__QSliderType__h__
