//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#ifndef __MuQt5__QTcpSocketType__h__
#define __MuQt5__QTcpSocketType__h__
#include <iostream>
#include <Mu/Class.h>
#include <Mu/MuProcess.h>
#include <QtCore/QtCore>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtNetwork/QtNetwork>
#include <QtWebEngine/QtWebEngine>
#include <QtWebEngineWidgets/QtWebEngineWidgets>
#include <QtQml/QtQml>
#include <QtQuick/QtQuick>
#include <QtQuickWidgets/QtQuickWidgets>
#include <QtSvg/QtSvg>
#include <MuQt5/Bridge.h>

namespace Mu
{
    class MuQt_QTcpSocket;

    //
    //  NOTE: file generated by qt2mu.py
    //

    class QTcpSocketType : public Class
    {
    public:
        typedef MuQt_QTcpSocket MuQtType;
        typedef QTcpSocket QtType;

        //
        //  Constructors
        //

        QTcpSocketType(Context* context, const char* name,
                       Class* superClass = 0, Class* superClass2 = 0);

        virtual ~QTcpSocketType();

        static bool isInheritable() { return true; }

        static inline ClassInstance* cachedInstance(const MuQtType*);

        //
        //  Class API
        //

        virtual void load();

        MemberFunction* _func[15];
    };

    // Inheritable object

    class MuQt_QTcpSocket : public QTcpSocket
    {
    public:
        virtual ~MuQt_QTcpSocket();
        MuQt_QTcpSocket(Pointer muobj, const CallEnvironment*, QObject* parent);
        virtual void disconnectFromHost();
        virtual void resume();
        virtual void setReadBufferSize(qint64 size);
        virtual void setSocketOption(QAbstractSocket::SocketOption option,
                                     const QVariant& value);
        virtual QVariant socketOption(QAbstractSocket::SocketOption option);
        virtual bool waitForConnected(int msecs);
        virtual bool waitForDisconnected(int msecs);
        virtual bool atEnd() const;
        virtual qint64 bytesAvailable() const;
        virtual qint64 bytesToWrite() const;
        virtual bool canReadLine() const;
        virtual void close();
        virtual bool isSequential() const;
        virtual bool waitForBytesWritten(int msecs);
        virtual bool waitForReadyRead(int msecs);

    public:
        const QTcpSocketType* _baseType;
        ClassInstance* _obj;
        const CallEnvironment* _env;
    };

    inline ClassInstance*
    QTcpSocketType::cachedInstance(const QTcpSocketType::MuQtType* obj)
    {
        return obj->_obj;
    }

} // namespace Mu

#endif // __MuQt__QTcpSocketType__h__
