//
// Copyright (c) 2009, Jim Hourihan
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
#include <MuQt5/qtUtils.h>
#include <MuQt5/QDesktopWidgetType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QtNetwork/QtNetwork>
#include <MuQt5/QWidgetType.h>
#include <MuQt5/QActionType.h>
#include <MuQt5/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt5/QCloseEventType.h>
#include <MuQt5/QDragMoveEventType.h>
#include <MuQt5/QPointType.h>
#include <MuQt5/QWheelEventType.h>
#include <MuQt5/QMouseEventType.h>
#include <MuQt5/QFocusEventType.h>
#include <MuQt5/QShowEventType.h>
#include <MuQt5/QSizeType.h>
#include <MuQt5/QDropEventType.h>
#include <MuQt5/QPaintEventType.h>
#include <MuQt5/QTabletEventType.h>
#include <MuQt5/QWidgetType.h>
#include <MuQt5/QDragLeaveEventType.h>
#include <MuQt5/QHideEventType.h>
#include <MuQt5/QMoveEventType.h>
#include <MuQt5/QDragEnterEventType.h>
#include <MuQt5/QEventType.h>
#include <MuQt5/QRectType.h>
#include <MuQt5/QContextMenuEventType.h>
#include <MuQt5/QKeyEventType.h>
#include <MuQt5/QVariantType.h>
#include <MuQt5/QResizeEventType.h>

//
//  NOTE: this file was automatically generated by qt2mu.py
//

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    void MuQt_QDesktopWidget::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::resizeEvent(event);
        }
    }

    bool MuQt_QDesktopWidget::hasHeightForWidth() const
    {
        if (!_env)
            return QDesktopWidget::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QDesktopWidget::hasHeightForWidth();
        }
    }

    int MuQt_QDesktopWidget::heightForWidth(int w) const
    {
        if (!_env)
            return QDesktopWidget::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QDesktopWidget::heightForWidth(w);
        }
    }

    QVariant
    MuQt_QDesktopWidget::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QDesktopWidget::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QDesktopWidget::inputMethodQuery(query);
        }
    }

    QSize MuQt_QDesktopWidget::minimumSizeHint() const
    {
        if (!_env)
            return QDesktopWidget::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QDesktopWidget::minimumSizeHint();
        }
    }

    QSize MuQt_QDesktopWidget::sizeHint() const
    {
        if (!_env)
            return QDesktopWidget::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QDesktopWidget::sizeHint();
        }
    }

    void MuQt_QDesktopWidget::changeEvent(QEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::changeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::changeEvent(event);
        }
    }

    void MuQt_QDesktopWidget::closeEvent(QCloseEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::closeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QCloseEventType>(c, event, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::closeEvent(event);
        }
    }

    void MuQt_QDesktopWidget::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::contextMenuEvent(event);
        }
    }

    void MuQt_QDesktopWidget::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::dragEnterEvent(event);
        }
    }

    void MuQt_QDesktopWidget::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::dragLeaveEvent(event);
        }
    }

    void MuQt_QDesktopWidget::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::dragMoveEvent(event);
        }
    }

    void MuQt_QDesktopWidget::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::dropEvent(event);
        }
    }

    void MuQt_QDesktopWidget::enterEvent(QEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::enterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::enterEvent(event);
        }
    }

    void MuQt_QDesktopWidget::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::focusInEvent(event);
        }
    }

    bool MuQt_QDesktopWidget::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QDesktopWidget::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QDesktopWidget::focusNextPrevChild(next);
        }
    }

    void MuQt_QDesktopWidget::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::focusOutEvent(event);
        }
    }

    void MuQt_QDesktopWidget::hideEvent(QHideEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::hideEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, event, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::hideEvent(event);
        }
    }

    void MuQt_QDesktopWidget::keyPressEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::keyPressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::keyPressEvent(event);
        }
    }

    void MuQt_QDesktopWidget::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::keyReleaseEvent(event);
        }
    }

    void MuQt_QDesktopWidget::leaveEvent(QEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::leaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::leaveEvent(event);
        }
    }

    void MuQt_QDesktopWidget::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QDesktopWidget::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::mouseMoveEvent(event);
        }
    }

    void MuQt_QDesktopWidget::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::mousePressEvent(event);
        }
    }

    void MuQt_QDesktopWidget::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::mouseReleaseEvent(event);
        }
    }

    void MuQt_QDesktopWidget::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::moveEvent(event);
        }
    }

    void MuQt_QDesktopWidget::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::paintEvent(event);
        }
    }

    void MuQt_QDesktopWidget::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::showEvent(event);
        }
    }

    void MuQt_QDesktopWidget::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::tabletEvent(event);
        }
    }

    void MuQt_QDesktopWidget::wheelEvent(QWheelEvent* event)
    {
        if (!_env)
        {
            QDesktopWidget::wheelEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QWheelEventType>(c, event, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QDesktopWidget::wheelEvent(event);
        }
    }

    bool MuQt_QDesktopWidget::event(QEvent* event_)
    {
        if (!_env)
            return QDesktopWidget::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QDesktopWidget::event(event_);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QDesktopWidgetType::QDesktopWidgetType(Context* c, const char* name,
                                           Class* super, Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QDesktopWidgetType::~QDesktopWidgetType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QDesktopWidget_QDesktopWidget_QObject(Thread& NODE_THREAD,
                                                         Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QDesktopWidget* w = object<QDesktopWidget>(widget))
        {
            QDesktopWidgetType* type =
                c->findSymbolOfTypeByQualifiedName<QDesktopWidgetType>(
                    c->internName("qt.QDesktopWidget"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QDesktopWidget_QDesktopWidget_QObject(
            NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_screen)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        int arg1 = (int)(param_screen);
        return makeqtype<QRectType>(c, arg0->availableGeometry(arg1),
                                    "qt.QRect");
    }

    Pointer qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_widget)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        const QWidget* arg1 = object<QWidget>(param_widget);
        return makeqtype<QRectType>(c, arg0->availableGeometry(arg1),
                                    "qt.QRect");
    }

    Pointer qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_p)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_p);
        return makeqtype<QRectType>(c, arg0->availableGeometry(arg1),
                                    "qt.QRect");
    }

    Pointer qt_QDesktopWidget_screen_QWidget_QDesktopWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_screen_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        int arg1 = (int)(param_screen_);
        return makeinstance<QWidgetType>(c, arg0->screen(arg1), "qt.QWidget");
    }

    Pointer qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_screen)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        int arg1 = (int)(param_screen);
        return makeqtype<QRectType>(c, arg0->screenGeometry(arg1), "qt.QRect");
    }

    Pointer qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_widget)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        const QWidget* arg1 = object<QWidget>(param_widget);
        return makeqtype<QRectType>(c, arg0->screenGeometry(arg1), "qt.QRect");
    }

    Pointer qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_p)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_p);
        return makeqtype<QRectType>(c, arg0->screenGeometry(arg1), "qt.QRect");
    }

    int qt_QDesktopWidget_screenNumber_int_QDesktopWidget_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_widget)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        const QWidget* arg1 = object<QWidget>(param_widget);
        return arg0->screenNumber(arg1);
    }

    int qt_QDesktopWidget_screenNumber_int_QDesktopWidget_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_point)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_point);
        return arg0->screenNumber(arg1);
    }

    void qt_QDesktopWidget_resizeEvent_void_QDesktopWidget_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->resizeEvent_pub(arg1);
    }

    bool qt_QDesktopWidget_hasHeightForWidth_bool_QDesktopWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        return isMuQtObject(arg0) ? arg0->QDesktopWidget::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QDesktopWidget_heightForWidth_int_QDesktopWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QDesktopWidget::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    Pointer qt_QDesktopWidget_inputMethodQuery_QVariant_QDesktopWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QDesktopWidget::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    Pointer qt_QDesktopWidget_minimumSizeHint_QSize_QDesktopWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c, arg0->QDesktopWidget::minimumSizeHint(), "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    Pointer
    qt_QDesktopWidget_sizeHint_QSize_QDesktopWidget(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QDesktopWidget::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    void qt_QDesktopWidget_changeEvent_void_QDesktopWidget_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->changeEvent_pub(arg1);
    }

    void qt_QDesktopWidget_closeEvent_void_QDesktopWidget_QCloseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->closeEvent_pub(arg1);
    }

    void
    qt_QDesktopWidget_contextMenuEvent_void_QDesktopWidget_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QDesktopWidget_dragEnterEvent_void_QDesktopWidget_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QDesktopWidget_dragLeaveEvent_void_QDesktopWidget_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QDesktopWidget_dragMoveEvent_void_QDesktopWidget_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QDesktopWidget_dropEvent_void_QDesktopWidget_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QDesktopWidget_enterEvent_void_QDesktopWidget_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->enterEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->enterEvent_pub(arg1);
    }

    void qt_QDesktopWidget_focusInEvent_void_QDesktopWidget_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QDesktopWidget_focusNextPrevChild_bool_QDesktopWidget_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QDesktopWidget*)arg0)
                         ->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QDesktopWidget*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QDesktopWidget_focusOutEvent_void_QDesktopWidget_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QDesktopWidget_hideEvent_void_QDesktopWidget_QHideEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QDesktopWidget_keyPressEvent_void_QDesktopWidget_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QDesktopWidget_keyReleaseEvent_void_QDesktopWidget_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QDesktopWidget_leaveEvent_void_QDesktopWidget_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->leaveEvent_pub(arg1);
    }

    void
    qt_QDesktopWidget_mouseDoubleClickEvent_void_QDesktopWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)
                ->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QDesktopWidget_mouseMoveEvent_void_QDesktopWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QDesktopWidget_mousePressEvent_void_QDesktopWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QDesktopWidget_mouseReleaseEvent_void_QDesktopWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QDesktopWidget_moveEvent_void_QDesktopWidget_QMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QDesktopWidget_paintEvent_void_QDesktopWidget_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->paintEvent_pub(arg1);
    }

    void qt_QDesktopWidget_showEvent_void_QDesktopWidget_QShowEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->showEvent_pub(arg1);
    }

    void qt_QDesktopWidget_tabletEvent_void_QDesktopWidget_QTabletEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->tabletEvent_pub(arg1);
    }

    void qt_QDesktopWidget_wheelEvent_void_QDesktopWidget_QWheelEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QDesktopWidget*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QDesktopWidget*)arg0)->wheelEvent_pub(arg1);
    }

    bool qt_QDesktopWidget_event_bool_QDesktopWidget_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QDesktopWidget* arg0 = object<QDesktopWidget>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0)
                   ? ((MuQt_QDesktopWidget*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QDesktopWidget*)arg0)->event_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_availableGeometry0, Pointer)
    {
        NODE_RETURN(
            qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_availableGeometry1, Pointer)
    {
        NODE_RETURN(
            qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_QWidget(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_availableGeometry2, Pointer)
    {
        NODE_RETURN(
            qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_QPoint(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_screen0, Pointer)
    {
        NODE_RETURN(qt_QDesktopWidget_screen_QWidget_QDesktopWidget_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_screenGeometry0, Pointer)
    {
        NODE_RETURN(qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_screenGeometry1, Pointer)
    {
        NODE_RETURN(
            qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_QWidget(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_screenGeometry2, Pointer)
    {
        NODE_RETURN(
            qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_QPoint(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_screenNumber0, int)
    {
        NODE_RETURN(qt_QDesktopWidget_screenNumber_int_QDesktopWidget_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_screenNumber1, int)
    {
        NODE_RETURN(qt_QDesktopWidget_screenNumber_int_QDesktopWidget_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QDesktopWidget_resizeEvent_void_QDesktopWidget_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QDesktopWidget_hasHeightForWidth_bool_QDesktopWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QDesktopWidget_heightForWidth_int_QDesktopWidget_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(
            qt_QDesktopWidget_inputMethodQuery_QVariant_QDesktopWidget_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QDesktopWidget_minimumSizeHint_QSize_QDesktopWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QDesktopWidget_sizeHint_QSize_QDesktopWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QDesktopWidget_changeEvent_void_QDesktopWidget_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QDesktopWidget_closeEvent_void_QDesktopWidget_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QDesktopWidget_contextMenuEvent_void_QDesktopWidget_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QDesktopWidget_dragEnterEvent_void_QDesktopWidget_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QDesktopWidget_dragLeaveEvent_void_QDesktopWidget_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QDesktopWidget_dragMoveEvent_void_QDesktopWidget_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QDesktopWidget_dropEvent_void_QDesktopWidget_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_enterEvent0, void)
    {
        qt_QDesktopWidget_enterEvent_void_QDesktopWidget_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QDesktopWidget_focusInEvent_void_QDesktopWidget_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(
            qt_QDesktopWidget_focusNextPrevChild_bool_QDesktopWidget_bool(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QDesktopWidget_focusOutEvent_void_QDesktopWidget_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QDesktopWidget_hideEvent_void_QDesktopWidget_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QDesktopWidget_keyPressEvent_void_QDesktopWidget_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QDesktopWidget_keyReleaseEvent_void_QDesktopWidget_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QDesktopWidget_leaveEvent_void_QDesktopWidget_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QDesktopWidget_mouseDoubleClickEvent_void_QDesktopWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QDesktopWidget_mouseMoveEvent_void_QDesktopWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QDesktopWidget_mousePressEvent_void_QDesktopWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QDesktopWidget_mouseReleaseEvent_void_QDesktopWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QDesktopWidget_moveEvent_void_QDesktopWidget_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QDesktopWidget_paintEvent_void_QDesktopWidget_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QDesktopWidget_showEvent_void_QDesktopWidget_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QDesktopWidget_tabletEvent_void_QDesktopWidget_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QDesktopWidget_wheelEvent_void_QDesktopWidget_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QDesktopWidget_event_bool_QDesktopWidget_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    void QDesktopWidgetType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QDesktopWidget_QDesktopWidget_QObject, Return,
                                ftn, Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "availableGeometry", _n_availableGeometry0, None, Compiled,
                qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_int,
                Return, "qt.QRect", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "screen", "int", Value((int)-1)), End),
            new Function(
                c, "availableGeometry", _n_availableGeometry1, None, Compiled,
                qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_QWidget,
                Return, "qt.QRect", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "widget", "qt.QWidget"), End),
            new Function(
                c, "availableGeometry", _n_availableGeometry2, None, Compiled,
                qt_QDesktopWidget_availableGeometry_QRect_QDesktopWidget_QPoint,
                Return, "qt.QRect", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "p", "qt.QPoint"), End),
            // PROP: isVirtualDesktop (bool; QDesktopWidget this)
            // PROP: primaryScreen (int; QDesktopWidget this)
            new Function(c, "screen", _n_screen0, None, Compiled,
                         qt_QDesktopWidget_screen_QWidget_QDesktopWidget_int,
                         Return, "qt.QWidget", Parameters,
                         new Param(c, "this", "qt.QDesktopWidget"),
                         new Param(c, "screen_", "int", Value((int)-1)), End),
            // PROP: screenCount (int; QDesktopWidget this)
            new Function(
                c, "screenGeometry", _n_screenGeometry0, None, Compiled,
                qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_int,
                Return, "qt.QRect", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "screen", "int", Value((int)-1)), End),
            new Function(
                c, "screenGeometry", _n_screenGeometry1, None, Compiled,
                qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_QWidget,
                Return, "qt.QRect", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "widget", "qt.QWidget"), End),
            new Function(
                c, "screenGeometry", _n_screenGeometry2, None, Compiled,
                qt_QDesktopWidget_screenGeometry_QRect_QDesktopWidget_QPoint,
                Return, "qt.QRect", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "p", "qt.QPoint"), End),
            new Function(
                c, "screenNumber", _n_screenNumber0, None, Compiled,
                qt_QDesktopWidget_screenNumber_int_QDesktopWidget_QWidget,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "widget", "qt.QWidget"), End),
            new Function(
                c, "screenNumber", _n_screenNumber1, None, Compiled,
                qt_QDesktopWidget_screenNumber_int_QDesktopWidget_QPoint,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "point", "qt.QPoint"), End),
            _func[0] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QDesktopWidget_resizeEvent_void_QDesktopWidget_QResizeEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[1] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QDesktopWidget_hasHeightForWidth_bool_QDesktopWidget, Return,
                "bool", Parameters, new Param(c, "this", "qt.QDesktopWidget"),
                End),
            _func[2] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QDesktopWidget_heightForWidth_int_QDesktopWidget_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "w", "int"), End),
            _func[3] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QDesktopWidget_inputMethodQuery_QVariant_QDesktopWidget_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "query", "int"), End),
            _func[4] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QDesktopWidget_minimumSizeHint_QSize_QDesktopWidget, Return,
                "qt.QSize", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"), End),
            _func[5] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QDesktopWidget_sizeHint_QSize_QDesktopWidget, Return,
                "qt.QSize", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"), End),
            // MISSING: paintEngine ("QPaintEngine *"; QDesktopWidget this)
            // MISSING: actionEvent (void; QDesktopWidget this, "QActionEvent *"
            // event) // protected
            _func[6] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QDesktopWidget_changeEvent_void_QDesktopWidget_QEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[7] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QDesktopWidget_closeEvent_void_QDesktopWidget_QCloseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QCloseEvent"), End),
            _func[8] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QDesktopWidget_contextMenuEvent_void_QDesktopWidget_QContextMenuEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[9] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QDesktopWidget_dragEnterEvent_void_QDesktopWidget_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[10] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QDesktopWidget_dragLeaveEvent_void_QDesktopWidget_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[11] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QDesktopWidget_dragMoveEvent_void_QDesktopWidget_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[12] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QDesktopWidget_dropEvent_void_QDesktopWidget_QDropEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QDropEvent"), End),
            _func[13] = new MemberFunction(
                c, "enterEvent", _n_enterEvent0, None, Compiled,
                qt_QDesktopWidget_enterEvent_void_QDesktopWidget_QEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[14] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QDesktopWidget_focusInEvent_void_QDesktopWidget_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[15] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QDesktopWidget_focusNextPrevChild_bool_QDesktopWidget_bool,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "next", "bool"), End),
            _func[16] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QDesktopWidget_focusOutEvent_void_QDesktopWidget_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[17] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QDesktopWidget_hideEvent_void_QDesktopWidget_QHideEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QHideEvent"), End),
            // MISSING: inputMethodEvent (void; QDesktopWidget this,
            // "QInputMethodEvent *" event) // protected
            _func[18] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QDesktopWidget_keyPressEvent_void_QDesktopWidget_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[19] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QDesktopWidget_keyReleaseEvent_void_QDesktopWidget_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[20] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QDesktopWidget_leaveEvent_void_QDesktopWidget_QEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[21] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QDesktopWidget_mouseDoubleClickEvent_void_QDesktopWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[22] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QDesktopWidget_mouseMoveEvent_void_QDesktopWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[23] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QDesktopWidget_mousePressEvent_void_QDesktopWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[24] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QDesktopWidget_mouseReleaseEvent_void_QDesktopWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[25] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QDesktopWidget_moveEvent_void_QDesktopWidget_QMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QDesktopWidget this, QByteArray
            // eventType, "void *" message, "long *" result) // protected
            _func[26] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QDesktopWidget_paintEvent_void_QDesktopWidget_QPaintEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[27] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QDesktopWidget_showEvent_void_QDesktopWidget_QShowEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[28] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QDesktopWidget_tabletEvent_void_QDesktopWidget_QTabletEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            _func[29] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QDesktopWidget_wheelEvent_void_QDesktopWidget_QWheelEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event", "qt.QWheelEvent"), End),
            _func[30] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QDesktopWidget_event_bool_QDesktopWidget_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QDesktopWidget"),
                new Param(c, "event_", "qt.QEvent"), End),
            // MISSING: initPainter (void; QDesktopWidget this, "QPainter *"
            // painter) // protected MISSING: metric (int; QDesktopWidget this,
            // "PaintDeviceMetric" m) // protected static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QDesktopWidget::staticMetaObject, propExclusions);
    }

} // namespace Mu
